VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5865
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   5865
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgSelectColor 
      Left            =   2520
      Top             =   720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblColor 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.Label lblName 
      Height          =   255
      Index           =   0
      Left            =   630
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SetSysColors Lib "user32" (ByVal nChanges As Long, lpSysColor As Long, lpColorValues As Long) As Long
Private Const COLOR_ACTIVEBORDER = 10
Private Const COLOR_ACTIVECAPTION = 2
Private Const COLOR_ADJ_MAX = 100
Private Const COLOR_ADJ_MIN = -100
Private Const COLOR_APPWORKSPACE = 12
Private Const COLOR_BACKGROUND = 1
Private Const COLOR_BTNFACE = 15
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNSHADOW = 16
Private Const COLOR_BTNTEXT = 18
Private Const COLOR_CAPTIONTEXT = 9
Private Const COLOR_GRAYTEXT = 17
Private Const COLOR_HIGHLIGHT = 13
Private Const COLOR_HIGHLIGHTTEXT = 14
Private Const COLOR_INACTIVEBORDER = 11
Private Const COLOR_INACTIVECAPTION = 3
Private Const COLOR_INACTIVECAPTIONTEXT = 19
Private Const COLOR_MENU = 4
Private Const COLOR_MENUTEXT = 7
Private Const COLOR_SCROLLBAR = 0
Private Const COLOR_WINDOW = 5
Private Const COLOR_WINDOWFRAME = 6
Private Const COLOR_WINDOWTEXT = 8

Private ColorNumbers As Collection
Private ColorNames As Collection
Private ColorValues As Collection

Private Sub Form_Load()
Const XGAP = 240
Const YGAP = 30
Dim xspacing As Single
Dim yspacing As Single
Dim i As Integer
Dim X1 As Single
Dim X2 As Single
Dim Y As Single

    Set ColorNumbers = New Collection
    Set ColorNames = New Collection
    Set ColorValues = New Collection

    ' Load the color names and numbers.
    ColorNumbers.Add COLOR_ACTIVEBORDER
    ColorNames.Add "COLOR_ACTIVEBORDER"
    ColorNumbers.Add COLOR_ACTIVECAPTION
    ColorNames.Add "COLOR_ACTIVECAPTION"
    ColorNumbers.Add COLOR_ADJ_MAX
    ColorNames.Add "COLOR_ADJ_MAX"
    ColorNumbers.Add COLOR_ADJ_MIN
    ColorNames.Add "COLOR_ADJ_MIN"
    ColorNumbers.Add COLOR_APPWORKSPACE
    ColorNames.Add "COLOR_APPWORKSPACE"
    ColorNumbers.Add COLOR_BACKGROUND
    ColorNames.Add "COLOR_BACKGROUND"
    ColorNumbers.Add COLOR_BTNFACE
    ColorNames.Add "COLOR_BTNFACE"
    ColorNumbers.Add COLOR_BTNHIGHLIGHT
    ColorNames.Add "COLOR_BTNHIGHLIGHT"
    ColorNumbers.Add COLOR_BTNSHADOW
    ColorNames.Add "COLOR_BTNSHADOW"
    ColorNumbers.Add COLOR_BTNTEXT
    ColorNames.Add "COLOR_BTNTEXT"
    ColorNumbers.Add COLOR_CAPTIONTEXT
    ColorNames.Add "COLOR_CAPTIONTEXT"
    ColorNumbers.Add COLOR_GRAYTEXT
    ColorNames.Add "COLOR_GRAYTEXT"
    ColorNumbers.Add COLOR_HIGHLIGHT
    ColorNames.Add "COLOR_HIGHLIGHT"
    ColorNumbers.Add COLOR_HIGHLIGHTTEXT
    ColorNames.Add "COLOR_HIGHLIGHTTEXT"
    ColorNumbers.Add COLOR_INACTIVEBORDER
    ColorNames.Add "COLOR_INACTIVEBORDER"
    ColorNumbers.Add COLOR_INACTIVECAPTION
    ColorNames.Add "COLOR_INACTIVECAPTION"
    ColorNumbers.Add COLOR_INACTIVECAPTIONTEXT
    ColorNames.Add "COLOR_INACTIVECAPTIONTEXT"
    ColorNumbers.Add COLOR_MENU
    ColorNames.Add "COLOR_MENU"
    ColorNumbers.Add COLOR_MENUTEXT
    ColorNames.Add "COLOR_MENUTEXT"
    ColorNumbers.Add COLOR_SCROLLBAR
    ColorNames.Add "COLOR_SCROLLBAR"
    ColorNumbers.Add COLOR_WINDOW
    ColorNames.Add "COLOR_WINDOW"
    ColorNumbers.Add COLOR_WINDOWFRAME
    ColorNames.Add "COLOR_WINDOWFRAME"
    ColorNumbers.Add COLOR_WINDOWTEXT
    ColorNames.Add "COLOR_WINDOWTEXT"

    ' Get the color values.
    For i = 1 To ColorNames.Count
        ColorValues.Add GetSysColor(ColorNumbers(i))
    Next i

    ' Display the colors.
    yspacing = lblColor(0).Height + YGAP
    xspacing = lblName(0).Left + _
        lblName(0).Width - lblColor(0).Left + XGAP
    Y = lblName(0).Top
    X1 = lblName(0).Left
    X2 = lblColor(0).Left
    For i = 1 To ColorNames.Count
        Load lblName(i)
        With lblName(i)
            .Left = X1
            .Top = Y
            .Caption = ColorNames(i)
            .Visible = True
        End With

        Load lblColor(i)
        With lblColor(i)
            .Left = X2
            .Top = Y
            .BackColor = ColorValues(i)
            .Visible = True
        End With

        If i Mod 10 = 0 Then
            X1 = X1 + xspacing
            X2 = X2 + xspacing
            Y = lblName(0).Top
        Else
            Y = Y + yspacing
        End If
    Next i

    ' Size the form.
    Width = lblName(ColorNames.Count).Left + _
        lblName(ColorNames.Count).Width
    Height = Height - ScaleHeight + _
        lblColor(10).Top + _
        lblColor(10).Height + 120
End Sub

' Let the user select the color for this value.
Private Sub lblColor_Click(Index As Integer)
Dim color_number As Long
Dim color_value As Long

    dlgSelectColor.Color = ColorValues(Index)
    dlgSelectColor.CancelError = True

    ' Present the color selection dialog.
    On Error Resume Next
    dlgSelectColor.ShowColor
    If Err.Number <> 0 Then Exit Sub

    ' Change the color.
    color_number = ColorNumbers(Index)
    color_value = dlgSelectColor.Color
    SetSysColors 1, color_number, color_value
    lblColor(Index).BackColor = color_value
End Sub
